
#include "driver.h"
#include "extension.h"


static wchar_t exts[MAX_EXTENSION][8] = 
{
    L"exe", L"bat", L"dll", L"cmd",
    L"inf", L"sys", L"scr",
};


int extension_allow( wchar_t* ext )
{
	int i;
	if( _wcsnicmp( ext, L"", 8 )==0 )
		return 1;
	for( i=0; i<MAX_EXTENSION; i++ )
	{
		if( _wcsnicmp( exts[i], ext, 8 )==0 )
		{
			return 0;
		}
	}
	return 1;
}

//note: we need to consider the race condition here.
int extension_add( wchar_t* ext )
{
	int i;
	if( extension_allow( ext ) )
		return 1;
	for( i=0; i<MAX_EXTENSION; i++ )
	{
		if( _wcsnicmp( exts[i], L"", 8 )==0 )
		{
			wcsncpy( exts[i], ext, 8 );
			return 1;
		}
	}
	dprint("extension array is full!\n");
	return 0;
}

int extension_del( wchar_t* ext )
{
	int i;
	for( i=0; i<MAX_EXTENSION; i++ )
	{
		if( _wcsnicmp( exts[i], ext, 8 )==0 )
		{
			wcsncpy( exts[i], L"", 1 );
			return 1;
		}
	}
	return 0;
}


