#include "driver.h"
#include "util.h"
#include "file_node.h"

void mut_init( int* mut )
{
	*mut = 1;
}

//mutex!!
int mut_down( int* mut)
{
_WAIT:
	(*mut)--;
	if( (*mut) ) //if *mut != 0, means failed!!
	{
		(*mut)++;
		ksleep(100);	//sleep for 100ms.
		if( prot_status( PS_GET ) == PS_IGNORE )
		//system is stoped, no need to wait
			return -1;
		goto _WAIT;
	}
	return 0;
}

//mutex!!
int mut_down2( int* mut, int timeout )
{
	timeout *= 10;
_WAIT:
	(*mut)--;
	if( (*mut) ) //if *mut != 0, means failed!!
	{
		(*mut)++;
		ksleep(100);	//sleep for 100ms.
		if( timeout == 0 )
		{
			dprint("timeout.");
			return -1;
		}
		timeout--;
		if( prot_status( PS_GET ) == PS_IGNORE )
		//system is stoped, no need to wait
			return -1;
		goto _WAIT;
	}
	return 0;
}
//
void mut_up( int* mut )
{
	//warning here.
	(*mut)++;
}


void state_init( state_t* s )
{
	if( !s ) return;
	s->state = 0;
	s->on = 0;
	mut_init( &s->mutex );
}

//wait for state
int state_wait( state_t* s, int st )
{
	int old, timeout=0;
	old = s->state;
_WAIT:
	if( prot_status( PS_GET ) == PS_IGNORE )
	//system is stoped, no need to wait
		return -1;
	ksleep(100);	//sleep for 100ms.
	if( s->state == st ){
		return 0;
	}
	timeout++;
	if( timeout > 5*60*10 ){
		dprint("state_wait : timeout. ");
		return -2;
	}
	goto _WAIT;
}

void state_set( state_t*s , int st )
{
	mut_down( &s->mutex );
	s->state = st;
	mut_up( &s->mutex );
}


//allocate memory
void* kmem_get( int size )
{
	return (void*) ExAllocatePool( NonPagedPool, size );
}

//free memory
void kmem_free( void* ptr )
{
	ExFreePool( ptr );
}

void ksleep(int ms)
{
	KTIMER ktimer;
	LARGE_INTEGER liTimerout;
	liTimerout.QuadPart=-(LONG)(ms*10000);
	KeInitializeTimer(&ktimer);
	KeWaitForSingleObject(&ktimer,Executive,KernelMode,FALSE,&liTimerout);

	/*
	LARGE_INTEGER interval;
	interval.QuadPart = (ms * DELAY_ONE_SECOND)/1000;      //delay n ms
	KeDelayExecutionThread( KernelMode, FALSE, &interval );
	*/
}

void zprint( wchar_t* ws )
{
	UNICODE_STRING ustring;
	ANSI_STRING  astring ;
	RtlInitUnicodeString( &ustring, ws );
	RtlUnicodeStringToAnsiString( &astring, &ustring, TRUE );
	DbgPrint("%s", astring.Buffer);
	RtlFreeAnsiString(&astring);
	RtlFreeUnicodeString(&ustring);
}

